#Program to process trades in the background as people enter them.
#It also updates the limit order book and trader balances. 

import string
import os
from time import sleep
from math import fmod, exp
import glob
from random import seed, random, gauss


def process_trade(buyer,seller,numshs,price,stkp):
	shs = string.atof(numshs)
	prc = string.atof(price)
	
	#PROCESS BUYER
	bstr = "trader_" + buyer + ".html"
	buyer_file = open(bstr,'r')
	cash = buyer_file.readline().strip()
	stk = buyer_file.readline().strip()
	cash = str(string.atof(cash) - shs * prc)
	stk = str(string.atof(stk) + shs)
	buyer_file.close()
	buyer_file = open(bstr,'w')
	buyer_file.write(cash + "\n" + stk + "\n")
	buyer_file.close()
	
	#PROCESS SELLER
	sstr = "trader_" + seller + ".html"
	seller_file = open(sstr,'r')
	cash = seller_file.readline().strip()
	stk = seller_file.readline().strip()
	cash = str(string.atof(cash) + shs * prc)
	stk = str(string.atof(stk) - shs)
	seller_file.close()
	seller_file = open(sstr,'w')
	seller_file.write(cash + "\n" + stk + "\n")
	seller_file.close()
	
	#WRITE TO TRADE FILE
	trfile = open("trades.temp",'w')
	trfile.write(buyer +","+ seller +","+ numshs +","+ price +"\n")
	trfile.close()
	os.system('cat trades.dat trades.temp > trades')
	os.system('mv trades trades.dat')

	#WRITE TO PRICES FILE
	trfile = open("prices.temp",'w')
	trfile.write(numshs +","+ price + "," + str(stkp) + "\n")
	trfile.close()
	os.system('cat prices.dat prices.temp > prices')
	os.system('mv prices prices.dat')
	os.system('./priceplot.run')  #Call Octave to create the stock chart

def process_orders(stkp):
	eog = 0
	os.system('cp -p blank.dat orders.dat')
	os.system('cp -p tradefile.dat orders.dat')
	os.system('cp -p blank.dat tradefile.dat')
	
	#READ IN THE LIMIT ORDER BOOK AND STORE IT IN ARRAYS
	infile = open("lo_book.dat",'r')
	buys = []
	sells = []
	eof=0
	while eof==0:
		line = infile.readline().strip()
		if line=="":
			eof = 1
		else:
			one_order = line.split(',')
			if one_order[3] == '1':
				buys.append(one_order)
			else:
				sells.append(one_order)			
	infile.close()
	
	#DO TRADE PROCESSING AGAINST LIM ORDER BOOK
	infile = open("orders.dat",'r')
	eof = 0
	while eof == 0:
		line = infile.readline().strip()
		if line=="":
			eof = 1
		else:
			one_order = line.split(',')
			trader = one_order[0]
			numshs = string.atof(one_order[1])
			price = string.atof(one_order[2])
			if price == -99:
				eog = 1
				break
			type = one_order[3]
			eo_order = 0
			print trader, numshs, price, type
			while eo_order == 0:
				if type == '1':		#PROCESS BUY ORDER
					prices = []
					for order in sells:
						prices.append(string.atof(order[2]))
					if len(prices) > 0:
						minprice = min(prices)
						idx = prices.index(minprice)
					else:
						minprice = 999999.0
					if minprice <= price:
						process_trade(trader,sells[idx][0],str(min(numshs,string.atof(sells[idx][1]))),str(price),stkp)
						if numshs > string.atof(sells[idx][1]):
							numshs = str(string.atof(numshs) - string.atof(sells[idx][1]))
							one_order[1] = str(numshs)
							del sells[idx]
						elif numshs < string.atof(sells[idx][1]):
							sells[idx][1] = str(string.atof(sells[idx][1]) - numshs)
							eo_order = 1
						elif numshs == string.atof(sells[idx][1]):
							del sells[idx]
							eo_order = 1
					else:
						buys.append(one_order)
						eo_order = 1
				if type == '-1':	#PROCESS SELL ORDER
					prices = []
					for order in buys:
						prices.append(order[2])
					if len(prices) > 0:
						maxprice = max(prices)
						idx = prices.index(maxprice)
					else:
						maxprice = -999999.0
					if string.atof(maxprice) >= price:
						process_trade(buys[idx][0],trader,str(min(numshs,string.atof(buys[idx][1]))),str(price),stkp)
						if numshs > string.atof(buys[idx][1]):
							numshs = str(string.atof(numshs) - string.atof(buys[idx][1]))
							one_order[1] = str(numshs)
							del buys[idx]
						elif numshs < string.atof(buys[idx][1]):
							buys[idx][1] = str(string.atof(buys[idx][1]) - numshs)
							eo_order = 1
						elif numshs == string.atof(buys[idx][1]):
							del buys[idx]
							eo_order = 1
					else:
						sells.append(one_order)
						eo_order = 1
	infile.close()
	

		
	#WRITE LIMIT ORDER BOOK AND BID-ASK SPREADS
	if len(buys) + len(sells) > 0:
		outfile = open("lo_book.dat",'w')
		sprice = [999999.0]
		bprice = [0.0]
		for order in sells:
			outfile.write(order[0] +","+ order[1] +","+ order[2] +","+ order[3] +"\n")
			sprice.append(string.atof(order[2]))
		for order in buys:
			outfile.write(order[0] +","+ order[1] +","+ order[2] +","+ order[3] +"\n")
			bprice.append(string.atof(order[2]))
		outfile.close()
		
		#WRITE BID-ASK SPREAD
		outfile = open("bidask.dat",'w')
		outfile.write(str(max(bprice)) + " - " + str(min(sprice)) + "\n")
		outfile.close()

	return eog

def process_news(stkp,sigma,news_pct,news_error):
	stkp = stkp * exp(sigma/100.0 * gauss(0,1))
	trader_list = glob.glob("trader_*.html")
	for trader in trader_list:
		trader = trader[:-5]
		trader = trader+".news"
		traderfile = open(trader,'a')
		if random() < news_pct/100.0:
			stkp1 = stkp * exp(news_error/100.0 * gauss(0,1))
			if stkp1 > stkp:
				news_str = "Stock price not greater than " + str(stkp1) + "\n"
			else:
				news_str = "Stock price is greater than " + str(stkp1) + "\n"
			traderfile.write(news_str)
	traderfile.close()
	return stkp


def process_endofgame(stkp):
	trader_list = glob.glob("trader_*.html")
	plfile = open("final_balances.dat",'w')
	plfile.write("Final Stock Price = " + str(stkp) + "\n")
	plfile.write("Trader, Cash Balance, Stock Bal, Stock value, Portfolio value \n")
	for trader in trader_list:
		infile = open(trader,'r')
		cashbal = string.atof(infile.readline().strip())
		stkbal = string.atof(infile.readline().strip())
		stkvalue = stkbal * stkp
		portfoliovalue = cashbal + stkvalue
		trader = trader[7:]
		trader = trader[:-5]
		plfile.write(trader + ", " + str(cashbal) + ", " + str(stkbal) + ", " + str(stkvalue) + ", " + str(portfoliovalue) + "\n")
		infile.close()
	plfile.close()
		
		


######### MAIN PROGRAM ############
stime = 5   #SECS
seed()   #start random generator
newscount = 1

#Read in the game parameters
paramfile = open("game_params.dat",'r')
stkp = string.atof(paramfile.readline().strip())
news_time = string.atof(paramfile.readline().strip())
news_freq = news_time / stime # Implies news is released every newsfreq*stime seconds
sigma = string.atof(paramfile.readline().strip())
news_pct = string.atof(paramfile.readline().strip())
news_error = string.atof(paramfile.readline().strip())
paramfile.close()

eog = 0
while eog == 0:
	eog = process_orders(stkp)
	newscount = newscount + 1
	if fmod(newscount,news_freq)==0.0:
		stkp = process_news(stkp,sigma,news_pct,news_error)
	sleep(stime)

process_endofgame(stkp)

